import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Dragon here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Dragon extends Actor
{
    GreenfootSound BGM = new GreenfootSound("BGM.mp3");
    GreenfootSound Gameover = new GreenfootSound("Game_Over.mp3");
    SoundGUI gui = new SoundGUI();
    private GreenfootImage[] images=new GreenfootImage[3];
    private int fly=0; 
    private int num=0; 
    double boost = 0;
    double gravity = 0.7;
    double boost_speed = -6;
    boolean first_turn = true;
   
    public void firstTurn()
    {
        if (first_turn)
            {
                BGM.playLoop();
                first_turn = false;
            }   
    }
    
    public void musicStop()
    {
        if (BGM.isPlaying())
            {
                BGM.stop();
            }  
    }
    
    public void changeBGMStatus()
    {
        if (Greenfoot.getKey() == "space")
            {
                if(BGM.isPlaying())
                    {
                        musicStop();
                        SoundGUI gui = (SoundGUI) getWorld().getObjects(SoundGUI.class).get(0);
                        gui.setImage("play.png");
                    }
            
                else 
                    {
                        BGM.play();
                        SoundGUI gui = (SoundGUI) getWorld().getObjects(SoundGUI.class).get(0);
                        gui.setImage("stop.png");
                    } 
            }   
    }
    
    public void addedToWorld(World DragonWorld) //this method adds the animated to the world class.
    {
        for (int i=0; i<images.length; i++) //loop that initializes the png files.
        {
            images[i] = new GreenfootImage("frame"+ i +".png"); //initializes the images array.
        }    
        
        setImage(images[num]);
    }  
    
    private void dragonControl()
    {
        boost = boost + gravity; //gravity aglorithm. 
        
        if(Greenfoot.isKeyDown("up") == true) //if up arrow is pressed the dragon will fly up = boost.
          {
              boost = boost_speed;    
          } 
    }
    
    private void dragonAnimate()
    {
        if(fly==0) 
            {
                fly=5; //sets the flight speed. the higher the number the slower the animation rate.
            }
            
        if(fly==1) //initializes the flight animation.
        {
            setImage(images[num]); //setImage = images array.
            num++; //increments the images.
        
            if(num>=images.length)
              {
                  num=0;
              }    
        }
        
        if(fly>0)
            {
                fly--;//resets the images array.
            }   
    }
    
    private void dragonRotate()
    {
          if(boost < 1) //sets the rotation movement depending on the boost.
            {
                setRotation(-15);//15
            }
        else if(boost < 8)
                {
                    setRotation(0);
                }
        else if(boost < 12)
                {
                    setRotation(45); //50
                }
        else if(boost < 30)
                {
                    setRotation(70); //75
                }
    }
  
    public void dragonDead()
    {
        Greenfoot.playSound("sfx_hit.wav");
        BGM.stop();
        Greenfoot.playSound("Game_Over.mp3");
        GameOver gameOver = new GameOver();
        getWorld().addObject(gameOver, getWorld().getWidth()/2,getWorld().getHeight()/2);
        Greenfoot.stop();
    }
    
     public void silentdragonDead()
    {
        GameOver gameOver = new GameOver();
        getWorld().addObject(gameOver, getWorld().getWidth()/2,getWorld().getHeight()/2);
        Greenfoot.stop();
    }
    
    public void act() 
    {
        dragonAnimate();
        dragonControl();
        dragonRotate(); 
        firstTurn();
        changeBGMStatus();

        //Falls off the background.    
        if (getY() > getWorld().getHeight()-1)
            {
               if (!BGM.isPlaying())
                    {
                        silentdragonDead();
                    }
               
               else
                    {    
                        dragonDead();
                    }  
            }       
        //Hits bottom obstacle.        
        if (getOneIntersectingObject(Obstacle.class) != null)
            {
                if (!BGM.isPlaying())
                    {
                        silentdragonDead();
                    }
               
               else
                    {    
                        dragonDead();
                    }  
            }
        
        //Hits top obstacle.    
        if (getOneIntersectingObject(Obstacle2.class) != null)
            {
                if (!BGM.isPlaying())
                    {
                        silentdragonDead();
                    }
               
               else
                    {    
                        dragonDead();
                    } 
            }    
       
         //flies too high.
        if (getOneIntersectingObject(Blocker.class) != null)
            {
                if (!BGM.isPlaying())
                    {
                        silentdragonDead();
                    }
               
               else
                    {    
                        dragonDead();
                    }  
            }    
        setLocation (getX(), (int)(getY() + boost)); //sets location and flying capability.
    }  
} 