import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class DragonWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DragonWorld extends World
{
    Counter counter = new Counter();
    Blocker blocker = new Blocker();
    int obstacle_counter = 0;
    int dragon_counter = 0;
    int gap = 185; 
    public int score = 0;
    int first_obstacle = 330;
   
    /**
     * Constructor for objects of class DragonWorld.
     * 
     */
    public DragonWorld()
    {    
        // Create a new world with 800x600 cells with a cell size of 1x1 pixels.
        super(800, 600, 1, false); 

        setPaintOrder (Counter.class, ScoreGUI.class, SoundGUI.class, GameOver.class, Obstacle.class, Obstacle2.class,  Dragon.class);

        //adds the counter;
        addObject (counter, 66, 32 );
        counter.scoreCount(0);

        //adds dragon to the world.   
        addObject (new Dragon(),100 ,(int)(0.5*getHeight())); 

        //adds background for the score counter;
        addObject (new ScoreGUI(), 50, 30);

        //adds sound off and on graphic. 
        addObject (new SoundGUI(), 50, 550);
        
        //prevents dragon from flying out of visual view.
        addObject (new Blocker(), 400, -500);
           }

    public void generateObstacles()
    {
        int random = Greenfoot.getRandomNumber(getHeight() * 2/3);
        
        Obstacle cyclops = new Obstacle();
        Obstacle2 cyclops2 = new Obstacle2();
  
        addObject(cyclops, getWidth() + cyclops.getImage().getWidth()/2, getHeight() + cyclops.getImage().getHeight()/2 - 50 - random); // creates random obstacles.
        addObject(cyclops2, cyclops.getX(), cyclops.getY() - cyclops2.getImage().getHeight() - gap); //aligns top obstacle to the one in the bottom.       
    }
    
    public void act()
    {
        obstacle_counter++;

        if (obstacle_counter % 100 == 0)
        {
            generateObstacles();
        }  

        if (obstacle_counter >= first_obstacle)
        {
            if (dragon_counter % 100 == 0)
            {
                score++; 
                counter.scoreCount(score);
                Greenfoot.playSound("sfx_point.wav");   
            }

            dragon_counter++;  
        } 
    }
}